#include <vector>
#include <string>
#include <iostream>
#include <list>
#include <algorithm>
#include <functional>

//#include <slist>

#include <cstdlib>
#include <ctime>

#include <arbdb.h>
#include <arbdbt.h>

//#include "probe_group2.hxx"
#include "probe_search.hxx"

//#define DUMP

using namespace std;

#ifndef NDEBUG
//  ------------------------
//      void pg_guard()
//  ------------------------
void pg_guard() {
    printf("guard\n");
}
#endif

GBDATA *gb_main = 0;


//  -----------------------------------------------------------------------
//      void generate_GBT_TREE_hash_rek(GBT_TREE *node, GB_HASH *hash)
//  -----------------------------------------------------------------------
void generate_GBT_TREE_hash_rek(GBT_TREE *node, GB_HASH *hash) {
    if (node->is_leaf) {
        if (node->gb_node) {
            GBDATA *gb_name = GB_find(node->gb_node,"name",0,down_level);
            if (gb_name) {
                GBS_write_hash(hash,GB_read_char_pntr(gb_name),(long)node);
            }
        }
    }
    else {
        generate_GBT_TREE_hash_rek(node->leftson,hash);
        generate_GBT_TREE_hash_rek(node->rightson,hash);
    }
}

//  --------------------------------------------------------
//      GB_HASH *generate_GBT_TREE_hash(GBT_TREE *root)
//  --------------------------------------------------------
GB_HASH *generate_GBT_TREE_hash(GBT_TREE *root) {
    GB_HASH *hash = GBS_create_hash(GBS_SPECIES_HASH_SIZE,0);
	generate_GBT_TREE_hash_rek(root,hash);
    return hash;
}

//  -------------------------------------
//      void Tiefe::tiefe_berechnen()
//  -------------------------------------
void Tiefe::tiefe_berechnen(){
    const GBT_TREE*  h1;
    h1=p;
    tiefe=0;
    while(h1!=tree){tiefe++;h1=h1->father;}
}

//  ----------------------------------------------------------------
//      const GBT_TREE* Tiefe::lowest_father(class Tiefe* other)
//  ----------------------------------------------------------------
const GBT_TREE* Tiefe::lowest_father(class Tiefe* other){
    int bottom;
    int top;
    if (tiefe<=other->tiefe) {
        bottom=tiefe;
        top=other->tiefe;
        for (int i=top;i>bottom;i--) other->up();
    }
    else {
        bottom=other->tiefe;top=tiefe;
        for (int i=top;i>bottom;i--) up();
    }
    tiefe_berechnen();
    other->tiefe_berechnen();

    while(p!=other->get_p()) {
        up();other->up();
    }

    return p;
}


//  -----------------------------------------------
//      const GBT_TREE* Group::get_all_father()
//  -----------------------------------------------
const GBT_TREE* Group::get_all_father()
{
    tiefe_container tcon;

    for(unsigned i=0;i<li.size();i++)
    {
        Tiefe l(li[i].tree_place,tree);
        tcon.push_back(l);
    }
    while (tcon.size()>1)
    {
        Tiefe owan=tcon.front();
        tcon.erase(tcon.begin());
        Tiefe two=tcon.front();
        tcon.erase(tcon.begin());
        Tiefe three=Tiefe(owan.lowest_father(&two),tree);
        tcon.push_back(three);
    }

    if (tcon.size()<=1) return tcon.front().get_p();
    else {printf("Vektor >1\n");exit(0);}

}

//  --------------------------------------------------------------------------
//      bool Group::is_father(const GBT_TREE* father,const GBT_TREE* sohn)
//  --------------------------------------------------------------------------
bool Group::is_father(const GBT_TREE* father,const GBT_TREE* sohn){
    const GBT_TREE* h;
    h=sohn;
    while ((h!=father)&&(h!=tree))
	{
        h=h->father;
    }

    if (h==father) return true;
    else return false;
}

//  --------------------------------------
//      bool Group::is_lowest_father()
//  --------------------------------------
bool Group::is_lowest_father(){
    unsigned sum=0;
    unsigned sumr=0;
    unsigned suml=0;

    for(unsigned i=0;i<li.size();i++)
        if (is_father(lowest_father,li[i].tree_place)) sum++;

    for(unsigned i=0;i<li.size();i++)
        if (is_father(lowest_father->rightson,li[i].tree_place)) sumr++;

    for(unsigned i=0;i<li.size();i++)
        if (is_father(lowest_father->leftson,li[i].tree_place)) suml++;
    if (li.size()<=1) return true;
    if ( (sum==li.size()) && ((sumr<li.size())&&(sumr>0)) && ((suml<li.size())&&(suml>0)) ) return true;
    else return false;
}

//  ---------------------------------------------------------------
//      void POOL::Array2(PG_tree_nodes& nodes, GBT_TREE *node)
//  ---------------------------------------------------------------
void POOL::Array2(PG_tree_nodes& nodes, GBT_TREE *node){
    if (node->is_leaf) {
        if (node->gb_node) nodes.push_back(node);

    }
    else {
        Array2(nodes,node->leftson);
        Array2(nodes,node->rightson);
    }
}


//  ---------------------------------------------
//      int number_leaf(const GBT_TREE *node)
//  ---------------------------------------------
int number_leaf(const GBT_TREE *node){
    int sum=0;
    if (node->is_leaf) sum++;

    else
        sum=number_leaf(node->leftson)+number_leaf(node->rightson);

    return sum;
}

//  ---------------------------------
//      void POOL::createArray()
//  ---------------------------------
void POOL::createArray() {
    a.clear();
    Array2(a,tree);
}

//  ---------------------------------------------------
//      void POOL::create_markArray(GBT_TREE *tree)
//  ---------------------------------------------------
void POOL::create_markArray(GBT_TREE *tree){
    GBT_TREE *mnode;
    GBDATA *gbspecies;
    a.clear();

    GB_transaction dummy(gb_main);
    gbspecies=GBT_first_marked_species(gbmain);
    for(int i=1;gbspecies;i++)
    {
        mnode=ret_tree_pos( tree,gbspecies);
        a.push_back(mnode);

        gbspecies=GBT_next_marked_species(gbspecies);
    }
}



//  ------------------------------------------------------------------------
//      const char* Specie::get_aligm(char *use, GB_ERROR& error) const
//  ------------------------------------------------------------------------
const char* Specie::get_aligm(char *use, GB_ERROR& error) const {
    GBDATA *gb_data;
    GB_transaction dummy(gb_main);

    gb_data = GBT_read_sequence(gbp, use);
    if(!gb_data){
        error = (GB_ERROR)GB_export_error("Species '%s' has no sequence '%s'", GB_read_char_pntr(gb_data),use);
	    return 0;
    }
    char* ch;
    ch= GB_read_char_pntr(gb_data);

    return ch;
}

//  -----------------------------------------------------------
//      const char* Specie::get_name(GB_ERROR& error) const
//  -----------------------------------------------------------
const char* Specie::get_name(GB_ERROR& error) const{
    GB_transaction dummy(gb_main);

    pg_assert(gbp);
    GBDATA *gb_name = GB_find(gbp,"name",0,down_level);
    if (!gb_name) {
        error = GB_export_error("species has no name entry");
        return 0;
    }
    return GB_read_char_pntr(gb_name);
}

//  --------------------------------------------
//      Specie::Specie(const Specie& other)
//  --------------------------------------------
Specie::Specie(const Specie& other) {
    tree_place=other.tree_place;
    gbp=other.gbp;

    pg_assert(gbp);
    pg_assert(tree_place);
}

//  ------------------------------------------------------
//      Specie& Specie::operator=(const Specie& other)
//  ------------------------------------------------------
Specie& Specie::operator=(const Specie& other){

    tree_place=other.tree_place;
    gbp=other.gbp;

    pg_assert(gbp);
    pg_assert(tree_place);

    return *this;
}


// static members Group
double Group::ein_sond_wert;
double Group::ein_sond_wertq;

double Group::koefmintargets;
double Group::koefmishits;

double Group::norm;
double Group::norm_groesse;
bool Group::count_all_probes;


//Ein Teil von Gruppe wird zufaellig geaendert
//  --------------------------------------------------------
//      Group::Group( const Group& gr,double teil,int b)
//  --------------------------------------------------------
Group::Group( const Group& gr,double teil,int b)
    : a(gr.a)
{

    int j;

    int zufall;

    li=gr.li;
    size=gr.size;
    def=gr.def;
    inf=gr.inf;
    inf.bew=false;

    birth=b;
    group_gen=0;

    int i=(int)(gr.li.size()*teil/100);
    for (j=0;j<i;j++)
    {
        zufall=rand()%li.size();
        li.at(zufall)=li.back();
        li.pop_back();
    }

    for (j=0;j<i;j++)
    {
        GB_transaction dummy(gb_main);
        li.push_back(
                     Specie(return_out_array(rand()%a.size())));

    }

    size=gr.li.size();
    def=gr.def;
    inf=gr.inf;
    inf.bew=false;
    tree=gr.tree;

    if (gr.get_history().length()<200)
        history=gr.get_history()+'m';
    else { history=gr.get_history()+'m';history.erase(0,2);}
}// ende

//Kopierkonstruktor
//  -------------------------------------
//      Group::Group(const Group& gr)
//  -------------------------------------
Group::Group(const Group& gr)
    : li(gr.li), a(gr.a)
{
    size=gr.size;
    def=gr.def;
    inf=gr.inf;
    tree = gr.tree;
    birth=gr.birth;
    number_leaf=gr.number_leaf;
    group_gen=gr.group_gen;
    history=gr.history;
}

//  -------------------------------------------------
//      Group& Group::operator=(const Group& gr)
//  -------------------------------------------------
Group& Group::operator=(const Group& gr) {
    pg_assert(&a==&gr.a);
    li=gr.li;
    size=gr.size;
    def=gr.def;
    inf=gr.inf;
    tree=gr.tree;

    return *this;
}

//zwei Gruppe mischen und eine neue erzeugen
//  -----------------------------------------------------------------------------------------------------
//      Group:: Group(const Group& gr1,double teil1, const Group& gr2,double teil2,int b) : a(gr1.a)
//  -----------------------------------------------------------------------------------------------------
Group:: Group(const Group& gr1,double teil1, const Group& gr2,double teil2,int b) : a(gr1.a) {

    unsigned    int t1=(int)(gr1.li.size()*teil1/100);
    unsigned    int t2=(int)(gr2.li.size()*teil2/100);

    PG_species_container cont;

    setA seti;
#ifndef NDEBUG
    static int count;
    count++;
#endif

    bool* ar = new bool[gr2.get_li().size()];
    for (unsigned i=0;i<gr2.get_li().size();i++) ar[i]=false;

    while(seti.size()<t1) seti.insert(rand()%(gr1.get_li().size()-1));
    for (setA::iterator i=seti.begin(); i!=seti.end(); ++i) {
        cont.push_back(gr1.li.at(*i));
    }

    unsigned i=0;int h;bool all=false;
    while ( (i<t2)&&(!all) ){
        h=rand()%(gr2.get_li().size());
        ar[h]=true;

        if (!test_doppelte(gr2.li.at(h),cont)) {
            set_test(4);
            cont.push_back(gr2.li.at(h));i++;
        }
        else
        {
            all=true;
            for (unsigned j=0;j<gr2.get_li().size();j++)
                all=all&&ar[j];
        }
    }
    delete [] ar;
    li=cont;
    size=li.size();
    def=gr1.def;
    inf=gr2.inf;
    inf.bew=false;
    tree=gr1.tree;
    birth=b;
    group_gen=0;
    if (gr1.get_history().length()>=gr2.get_history().length())

        history=gr1.get_history()+"c";
    else  history=gr2.get_history()+"c";
    if (history.length()>200)
    {history.erase(0,2);}
}
/*----------------------------------------------------------*/
//zwei Gruppe mischen und zwei neue erzeugen
//  -------------------------------------------------------------------------------------------------------------------
//      Group:: Group(const Group& gr1,double teil1, const Group& gr2,double teil2,Group& zweite,int b) : a(gr1.a)
//  -------------------------------------------------------------------------------------------------------------------
Group:: Group(const Group& gr1,double teil1, const Group& gr2,double teil2,Group& zweite,int b) : a(gr1.a) {

    unsigned t1=(int)(((Group)gr1).li.size()*teil1/100);
    unsigned t2=(int)(((Group)gr2).li.size()*teil2/100);

    PG_species_container cont;

    setA seti;

    while(seti.size()<t1) seti.insert(rand()%((Group)gr1).get_li().size()-1);
    for (setA::iterator i=seti.begin(); i!=seti.end(); ++i) cont.push_back(gr1.li.at(*i));
    setA setn;
    {
        unsigned i=0;
        int h;
        while (i<t2){
            h=rand()%((Group)gr2).group_size();
            if (!test_doppelte(gr2.li.at(h),cont)) {
                cont.push_back(gr2.li.at(h));i++;
                setn.insert(h);
            }
        }
    }
    li=cont;
    size=li.size();
    def=gr1.def;
    inf=gr2.inf;
    inf.bew=false;
    tree=gr1.tree;
    birth=b;
    group_gen=0;

    if (gr1.get_history().length()>=gr2.get_history().length()) {
        history=gr1.get_history()+"c2";
    }
    else  {
        history=gr2.get_history()+"c2";
    }

    if (history.length()>200) {
        history.erase(0,2);
    }

    zweite.def=gr1.def;
    zweite.inf=gr1.inf;
    zweite.tree=gr1.tree;
    //    zweite.a=a;
    zweite.birth=b;
    zweite.group_gen=0;
    if (gr1.get_history().length()>=gr2.get_history().length()) {
        zweite.history=gr1.get_history()+"c2";
    }
    else  {
        zweite.history=gr2.get_history()+"c2";
    }
    if (zweite.get_history().length()>200) {
        zweite.history.erase(0,2);
    }

    for(unsigned i=0;i<gr1.li.size();i++)
        if (find(seti.begin(),seti.end(),int(i))==seti.end())
            zweite.li.push_back(gr1.li.at(i));

    for(unsigned i=0;i<gr2.li.size();i++)
        if (find(setn.begin(),setn.end(),int(i))==setn.end())
            if  (!test_doppelte(gr2.li.at(i),zweite.li))
                zweite.li.push_back(gr2.li.at(i));
}
/*----------------------------------------------------------*/
//Species aus Gruppe ausschneiden
//  -----------------------------------------------------------------------------------------
//      Group::Group(const Group& gr,const PG_species_container& out_l,int b) : a(gr.a)
//  -----------------------------------------------------------------------------------------
Group::Group(const Group& gr,const PG_species_container& out_l,int b) : a(gr.a)  {

    li=gr.li;
    size=gr.size;
    def=gr.def;
    inf=gr.inf;
    inf.bew=false;
    tree=gr.tree;
    birth=b;
    group_gen=0;
    if (gr.get_history().length()<200)
        history=gr.get_history()+'m';
    else { history=gr.get_history()+'m';history.erase(0,2);}


    gbmain=gr.gbmain;
    for ( PG_species_container::const_iterator i=out_l.begin(); i!=out_l.end(); ++i){
        PG_species_container:: iterator result=find(li.begin(),li.end(),*i);
        li.erase(result);
    }

    size=li.size();
}

//Species aus Gruppe zufaellig ausschneiden
//  -------------------------------------------------------------
//      Group::Group(const Group& gr,int kl,int b) : a(gr.a)
//  -------------------------------------------------------------
Group::Group(const Group& gr,int kl,int b) : a(gr.a) {

    int k1,g;


    li=gr.li;
    size=gr.size;
    def=gr.def;
    inf=gr.inf;
    inf.bew=false;
    tree=gr.tree;
    birth=b;
    group_gen=0;
    if (gr.get_history().length()<200)
        history=gr.get_history()+'m';
    else { history=gr.get_history()+'m';history.erase(0,2);}


    gbmain=gr.gbmain;

    for (g=1;g<=kl;g++){
        k1=rand()%li.size();
        li.at(k1)=li.back();
        li.pop_back();
    }

    size=li.size();

}




//Species zufuegen
//  ----------------------------------------------------------------------------------------------
//      Group::Group(const Group& gr,const PG_species_container& in_l,bool a,int b) : a(gr.a)
//  ----------------------------------------------------------------------------------------------
Group::Group(const Group& gr,const PG_species_container& in_l,bool a,int b) : a(gr.a) {

    li=gr.li;
    size=gr.size;
    def=gr.def;
    inf=gr.inf;
    inf.bew=false;
    tree=gr.tree;
    birth=b;
    group_gen=0;
    if (gr.get_history().length()<200)
        history=gr.get_history()+'m';
    else { history=gr.get_history()+'m';history.erase(0,2);}


    gbmain=gr.gbmain;
    for ( PG_species_container::const_iterator i=in_l.begin(); i!=in_l.end(); ++i)
        if (!test_doppelte(*i,((Group)gr).get_li())) li.push_back(*i);

    size=li.size();
}

//Species zufaellig zufuegen
//  ------------------------------------------------------------------------
//      Group::Group(const Group& gr,int kn,bool abool,int b) : a(gr.a)
//  ------------------------------------------------------------------------
Group::Group(const Group& gr,int kn,bool abool,int b) : a(gr.a) {
    li=gr.li;
    size=gr.size;
    def=gr.def;
    inf=gr.inf;
    inf.bew=false;
    tree=gr.tree;
    birth=b;
    group_gen=0;

    if (gr.get_history().length()<200) {
        history=gr.get_history()+'m';
    }
    else {
        history=gr.get_history()+'m';
        history.erase(0,2);
    }

    gbmain=gr.gbmain;

    GB_transaction dummy(gb_main);
    setA seti;
    while(seti.size()<unsigned(kn)) seti.insert(rand()%a.size());
    for (setA::iterator i=seti.begin(); i!=seti.end(); ++i)
        if (!test_doppelte(Specie(return_out_array(*i)),li))
            li.push_back(Specie(return_out_array(*i)));

    size=li.size();
}

//  ----------------------------------------------------------------------------------
//      Group::Group(GBDATA* gbm, GBT_TREE *tree_in,const PG_tree_nodes& a1):a(a1)
//  ----------------------------------------------------------------------------------
Group::Group(GBDATA* gbm, GBT_TREE *tree_in,const PG_tree_nodes& a1):a(a1){

    gbmain=gbm;
    tree=tree_in;

    group_gen=0;
    history="n";
}

//Konstruktor
//  -------------------------------------------------------------------------------------------------------------------------------
//      Group:: Group(int x,GBDATA* gbm, GBT_TREE *tree_in,bool v,const PG_tree_nodes& a1,int b,GBDATA*& first_mark_spec):a(a1)
//  -------------------------------------------------------------------------------------------------------------------------------
Group:: Group(int x,GBDATA* gbm, GBT_TREE *tree_in,bool v,const PG_tree_nodes& a1,int b,GBDATA*& first_mark_spec):a(a1){
    int i;
    GBDATA *gbspecies;
    gbmain=gbm;
    tree=tree_in;
    birth=b;
    group_gen=0;
    history="n";
    GBT_TREE* gbtree;

    set_test(4);

    GB_transaction dummy(gb_main);

    if (!v) //v -false ,dann werden markierte bakterien in der Gruppe zugefuegt

    {
        if (x>GBT_count_marked_species(gbmain)) {

            exit(0);
        }
		else printf("count_species=%li\n",GBT_count_marked_species(gbmain));

        gbspecies= first_mark_spec;
        for(i=1;(i<=x)&&gbspecies;i++)
        {
            gbtree=ret_tree_pos( tree,gbspecies);
            if (gbtree!=NULL) li.push_back(Specie(gbtree));
            else printf("NULL\n");
            gbspecies=GBT_next_marked_species(gbspecies);
        }
        first_mark_spec=gbspecies;
    }//v=false
    else //v -true, dann werden Bakterien aus Datensatz zufaellig gewaellt
    {
        setA seti;
        int a_size = a.size();
        if (a_size==0) {printf("Alle Species aus dem Baum sind nicht im Datenbank.\n");exit(0);}
        while(seti.size()<=unsigned(x)) {
            int to_insert = rand()%a_size;
            seti.insert(to_insert);
        }
        for (setA::iterator i=seti.begin(); i!=seti.end(); ++i) {
            li.push_back(Specie(return_out_array(*i)));
        }
    }
    size=li.size();
}

//Konstruktor mit Liste
//  -----------------------------------------------------------------------------------------------
//      Group:: Group(const PG_species_container& in_l,const PG_tree_nodes& a_in,int b):a(a_in)
//  -----------------------------------------------------------------------------------------------
Group:: Group(const PG_species_container& in_l,const PG_tree_nodes& a_in,int b):a(a_in){
    //a=a_in;
    li=in_l;
    size=in_l.size();
    birth=b;
    history="n";
#if defined (TEST_DOPPELTE)
    test_doppelte();
#endif
}

int Group::group_size(void){return li.size();}

//  -------------------------------------------------------------------------
//      GBDATA* Group::return_k_te_specie_indatensatz(int k, GBDATA* gbm)
//  -------------------------------------------------------------------------
GBDATA* Group::return_k_te_specie_indatensatz(int k, GBDATA* gbm){

    GBDATA* gbspecies;
    int j;

    //GB_MAIN_TYPE* gb_main=GB_MAIN(gbp1);
    GB_transaction dummy(gb_main);
    if (k>GBT_count_species(gbm)) return NULL;

    for(gbspecies=GBT_first_species(gbm), j=1; ((gbspecies)&&(j<k)); gbspecies=GBT_next_species(gbspecies), j++) ;
    return gbspecies;
}

//  ------------------------------------------------------
//      const GBT_TREE* Group::return_out_array(int k)
//  ------------------------------------------------------
const GBT_TREE* Group::return_out_array(int k){
    int g=0;
    if (unsigned(k)>a.size()) { printf("Array border out\n");return NULL;}
    while(g!=k) g=g+1;
    return a[g];
}

//  ----------------------------------------------------------------------------
//      bool Group::test_doppelte(Specie test,const PG_species_container& l)
//  ----------------------------------------------------------------------------
bool Group::test_doppelte(Specie test,const PG_species_container& l){
    bool in=false;

    for(unsigned i=0; i<l.size() && !in; i++)
        if (!(l[i]!=test))
            in=true;

    return in;
}

//  -----------------------------------------------------------
//      PG_species_container::iterator  Group::k_pos(int h)
//  -----------------------------------------------------------
PG_species_container::iterator  Group::k_pos(int h){

    PG_species_container::iterator it;
    if (h>group_size()) return li.end();
    int j=1;
    for (it=li.begin(); j<h; ++it,++j) ;
    return it;

}

//  ------------------------------------------------
//      long  Group::dist(Specie sp1,Specie sp2)
//  ------------------------------------------------
long  Group::dist(Specie sp1,Specie sp2){
    const GBT_TREE* h1;
    const GBT_TREE* h2;
    const GBT_TREE* h_top;
    const GBT_TREE* h_bottom;
    long len1=0;
    long len2=0;
    long len=0;
    long high1=0;
    long high2=0;

    h1=sp1.tree_place;
    h2=sp2.tree_place;

    while(h1!=tree){high1++;h1=h1->father;}
    while(h2!=tree){high2++;h2=h2->father;}

    h1=sp1.tree_place;
    h2=sp2.tree_place;

    while((high1>0)&&(high2>0)){h1=h1->father;high1--;len1++;
    h2=h2->father;high2--;len2++;}
    if ((high1==0)&&(high2==0))
    {if (h1==tree) return len1+len2-1;
    else return len1+len2;
    }
    if (high1==0) {h_top=h1;h_bottom=h2;}
    else
    {h_top=h2;h_bottom=h1;}

    while(h_top!=h_bottom){h_bottom=h_bottom->father;len++;}
    if (h_top==tree) len--;
    return len+len1+len2;

}

//  -----------------------------
//      long Group::alldist()
//  -----------------------------
long Group::alldist(){
    unsigned i,j;
    long all_dist=0;
    for (i=0;i<li.size();i++)
        for(j=0;j<li.size();j++)
            if (i!=j) {  long d=dist(li.at(i),li.at(j));
            all_dist=all_dist+d;

            }
    int all=1;
    int j1=li.size()-1;

    all=li.size()*j1;
    if (j1==0) all=1;


    return all_dist;
}

//  --------------------------------
//      double Group::rel_dist()
//  --------------------------------
double Group::rel_dist(){
    long dist=alldist();

    int all=1;
    int j1=li.size()-1;

    all=li.size()*j1;
    if (j1==0) all=1;
    if (all==0) return 0;
    else
        return dist/all;
}

//  ---------------------------------------------------------------------
//      GBT_TREE* Group::ret_tree_pos( GBT_TREE* t,GBDATA *gbspecies)
//  ---------------------------------------------------------------------
GBT_TREE* Group::ret_tree_pos( GBT_TREE* t,GBDATA *gbspecies){
    GBT_TREE *tl;
    GBT_TREE *tr;

    if (t->is_leaf)
    {
        if (t->gb_node==gbspecies) {return t;}
        else return NULL;
    }
    else
    {
        tl=ret_tree_pos(t->leftson,gbspecies);
        tr=ret_tree_pos(t->rightson,gbspecies);
        if (tl!=NULL) {return tl;}
        else
            if (tr!=NULL){return tr;}
            else return NULL;
    }
}

//  ------------------------------------
//      double Group::  bewertung()
//  ------------------------------------
double Group::  bewertung() {
    inf.bew=true;
    double mishitproc;
    double mintargetsproc;
    double erg;

    switch (def.mishit){
        case 10:mishitproc=1;break;
        case 9 :mishitproc=5;break;
        case 8 :mishitproc=20;break;
        case 7 :mishitproc=30;break;
        case 6 :mishitproc=40;break;
        case 5 :mishitproc=50;break;
        case 4 :mishitproc=60;break;
        case 3 :mishitproc=70;break;
        case 2 :mishitproc=80;break;
        case 1 :mishitproc=90;break;
        case 0 :mishitproc=100;break;
        default: pg_assert(0); break;
    }

    if (def.mintargets<70) {
        mintargetsproc=0.8*def.mintargets;
    }
    else {
        if (def.mintargets<90) {
            mintargetsproc=0.9*def.mintargets;
        }
        else {
            mintargetsproc=def.mintargets;
        }
    }

    double  d=rel_dist();
    double obd=divid(d);
    erg=(
         (koefmintargets*mintargetsproc)
         *
         (koefmishits*mishitproc)
         *
         ( count_all_probes
           // alle Sonden Qualitaeten gewertet
           ? (inf.qualitysond_sum*ein_sond_wertq + inf.seq_list.size()*ein_sond_wert +0.01)

           // nur die 2 besten Sonden Qualitaeten gewertet
           : ((inf.qualitysond_best+inf.qualitysond_second)*ein_sond_wertq + (inf.seq_list.size() >=2 ? 2 : inf.seq_list.size())*ein_sond_wert +0.01)
           )
         *
         (norm_groesse*li.size() * (def.mintargets/100.0))
         *
         (norm*obd) // obd = 1/mittl. Distanz aller Mitglieder-Paare
         );

    if (li.size()<=1) erg=0;

    return erg;
}

//  -------------------------------
//      void  Group::toString()
//  -------------------------------
void  Group::toString(){
    printf("Birth=%d\n",birth);
    for(unsigned i=0;i<inf.seq_list.size();i++)
        printf("%s\n",inf.seq_list[i].c_str());
    printf("\n");
}

//  -----------------------------------------------------------------------------------------------------------------------------
//      POOL::POOL(GBDATA* gbmain1,GBT_TREE* tree1,const string& ptserver_name, int x1,int y1,bool variante,bool all_not_all)
//  -----------------------------------------------------------------------------------------------------------------------------
POOL::POOL(GBDATA* gbmain1,GBT_TREE* tree1,const string& ptserver_name, int x1,int y1,bool variante,bool all_not_all){
    x=x1;
    poolsize=x1;
    y=y1;
    gbmain=gbmain1;
    tree=tree1;
    PtServerName = ptserver_name;
    generation=1;
	if (all_not_all)
        createArray();
	else create_markArray(tree1);

    if (variante) {
        int k;
        for (k=1;k<=x;k++) {
            GBDATA* gbsp;
            con.push_back(Group(y,gbmain,tree,true,a,generation,gbsp));
        }
    }
    else {
        GB_transaction dummy(gb_main);
        GBDATA* gbspecies;
        gbspecies=GBT_first_marked_species(gbmain);

        int k;
        for (k=1;k<=x;k++) {
            con.push_back(Group(y,gbmain,tree,false,a,generation,gbspecies));
        }

    }
}

//  --------------------------------------------------------------------
//      GBT_TREE* POOL::ret_tree_pos( GBT_TREE* t,GBDATA *gbspecies)
//  --------------------------------------------------------------------
GBT_TREE* POOL::ret_tree_pos( GBT_TREE* t,GBDATA *gbspecies){
    GBT_TREE *tl;
    GBT_TREE *tr;

    if (t->is_leaf) {
        if (t->gb_node==gbspecies) return t;
        return NULL;
    }
    else {
        tl=ret_tree_pos(t->leftson,gbspecies);
        tr=ret_tree_pos(t->rightson,gbspecies);
        if (tl!=NULL) return tl;
        if (tr!=NULL) return tr;
        return NULL;
    }
}

//  -----------------------------------------------------------------
//      bool POOL::search_pool(GBT_TREE* gbt_tree,GB_HASH* hash)
//  -----------------------------------------------------------------
bool POOL::search_pool(GBT_TREE* gbt_tree,GB_HASH* hash) {
    for (container_group::reverse_iterator i=con.rbegin(); i!=con.rend(); ++i) {
        if (!(*i).ist_bewertet()) {
            Specie *bad;
            bool success =false;
            int n=0;

            while(!success) {
                n++;

                GB_ERROR error = 0;
                success=PG_search_probes_and_rate_group(*i,PtServerName.c_str(),bad,error);
                if (! success) {
                    pg_assert(bad!=0 || error!=0);

                    if (bad!=0) {
                        for (PG_species_container::const_iterator s=(*i).get_li().begin(); s!=(*i).get_li().end(); ++s) {
                            if (s==bad) {
                                ((*i).get_li()).erase((Specie*)s);
                            }
                        }
                    }

                    if (error!=0) return false;
                }
            }

		 	if (  ( (*i).get_inf().seq_list.size()>0 ) && ( (*i).get_def().mishit>0 ) )
            {
                unsigned vor_size=(*i).get_li().size();
                GB_ERROR error = 0;

                probe_match_event(*i,PtServerName.c_str(),bad,error, gbt_tree,hash);
                (*i).get_def().mishit=0;
                if (vor_size<(*i).get_li().size()) {
                    success=PG_search_probes_and_rate_group(*i,PtServerName.c_str(),bad,error);
                }
                else {
                    (*i).get_def().mishit=0;
                }
                if (!(*i).ist_bewertet()) {
                    (*i).get_inf().quality=(*i).bewertung( );
                }
                ((PG_inform)((*i).get_inf())).bew=true;
                if (  ( (*i).get_inf().seq_list.size()>0 ) && ( (*i).get_def().mishit==0 ) ) {
                    match_con.push_back(*i);
                }
            }
        }

        double ist_sound,anzahl_sound;
        ist_sound=0.5;anzahl_sound=0.25;
        if (!(*i).ist_bewertet()) (*i).get_inf().quality=(*i).bewertung( );
        ((PG_inform)((*i).get_inf())).bew=true;
    }

    return true;
}

//  ----------------------------------
//      void POOL::replic(int del)
//  ----------------------------------
void POOL::replic(int del){
    double infer,suprem;

    infer=con.at(0).get_inf().quality;
    suprem=con.at(0).get_inf().quality;

    for(unsigned i=0;i<con.size();i++)
    {
        if (con[i].get_inf().quality<infer)
            infer=con[i].get_inf().quality ;
        if (con[i].get_inf().quality>suprem)
            suprem=con.at(i).get_inf().quality ;
    }
    double delta=0.05;
    if (suprem==infer) suprem=1.1*suprem;
    for(unsigned i=0;i<con.size();i++) {
        con.at(i).get_inf().fitness= ((con.at(i).get_inf().quality-infer)/((suprem-infer)*(1+2*delta)))+delta;
    }

    if (unsigned(del)>con.size()) return;

    int k=0;

    while(k<del) {
        int r=rand()%(con.size());
        int pr=rand()%100;

        if (pr>100*con.at(r).get_inf().fitness) {
            con.at(r)=con.back();
            con.pop_back();

            k=k+1;
        }
    }

    x=con.size();
}

//  -------------------------------------------------------------------------------------------------------------------------------------------------
//      bool POOL::step(int zufall1,int neue1,int mischen1,int treffen1,int groupsize, PG_inform& pgi,GBT_TREE* gbt_tree_step,GB_HASH* hash_step)
//  -------------------------------------------------------------------------------------------------------------------------------------------------
bool POOL::step(int zufall1,int neue1,int mischen1,int treffen1,int groupsize, PG_inform& pgi,GBT_TREE* gbt_tree_step,GB_HASH* hash_step){
    generation++;
    x=con.size();

    int zufall2;
    int neue2;
    int mischen2;
    int treffen2;
    bool* ar = new bool[con.size()+1];
    int n=con.size();
    int* rest_index=new int[n+1];


    zufall2=(x*zufall1)/100;
    neue2=(x*neue1)/100;
    mischen2=(x*mischen1)/(100*2);
    treffen2=(x*treffen1)/100;

    pg_assert(unsigned(x)==con.size());
    pg_assert((zufall2+mischen2*2+treffen2) <= x);

    container_group con1;
    int j;

    for(j=0;j<=n;j++) rest_index[j]=j;
    for(j=1;j<=x;j=j+1) ar[j]=true;

    for(j=1;j<=neue2;j++) {
        set_test(4);
        GBDATA* gbspecies;
        con.push_back(Group(y,gbmain,tree,true,a,generation,gbspecies));

        con.back().get_def().set_probelength(minprobelength);
        con.back().get_def().set_cliptresult(50);
        con.back().get_def().set_mintemp(30);
        con.back().get_def().set_maxtemp(100);
        con.back().get_def().set_mishit(himishit);
        con.back().get_def().set_mintargets(himintargets);
        con.back().get_def().set_mingc(50);
        con.back().get_def().set_maxgc(100);
        con.back().get_def().set_minpos(0);
        con.back().get_def().set_maxpos(10000);
        con.back().get_def().set_dtedge(0.5);
        con.back().get_def().set_dt(0.5);
        con.back().get_def().set_split(0.5);
        con.back().get_def().set_bondval(0,0);
        con.back().get_def().set_bondval(0,1);
        con.back().get_def().set_bondval(0.5,2);
        con.back().get_def().set_bondval(1.1,3);
        con.back().get_def().set_bondval(0,4);
        con.back().get_def().set_bondval(0,5);
        con.back().get_def().set_bondval(1.5,6);
        con.back().get_def().set_bondval(0,7);
        con.back().get_def().set_bondval(0.5,8);
        con.back().get_def().set_bondval(1.5,9);
        con.back().get_def().set_bondval(0.4,10);
        con.back().get_def().set_bondval(0.9,11);
        con.back().get_def().set_bondval(1.1,12);
        con.back().get_def().set_bondval(0,13);
        con.back().get_def().set_bondval(0.9,14);
        con.back().get_def().set_bondval(0,15);
        con.back().get_def().set_maxbonds(4);
        con.back().set_inf(pgi);
    }

    for(j=1;j<=treffen2;j++) {
        int h=rand()%n;

        int h1=rest_index[h];
        rest_index[h]=rest_index[n];
        n=n-1;
        con.push_back(Group(con.at(h1),((PG_inform)(con.at(h1)).get_inf()).treffen_list,generation));

        x=con.size();
    }

    for(j=1;j<=zufall2;j++) {
        int h=rand()%n;
        int h1=rest_index[h];
        rest_index[h]=rest_index[n];
        n=n-1;
        if (con.at(h1).get_li().size()<2) {
            con.push_back(Group(con.at(h1),2,true,generation));
        }
        else {
            unsigned int l=rand()%2;
            if (l>0) {
                con.push_back(Group(con.at(h1),50.0,generation));
            }
            else {
                if (con.at(h1).get_li().size()<unsigned(groupsize)) {
                    con.push_back(Group(con.at(h1),2,true,generation));
                }
                else {
                    con.push_back(Group(con.at(h1),50.0,generation));
                }
            }
        }
        con.back().get_def().set_probelength(mut_probelength(con.back().get_def().probelength));
        con.back().get_def().set_mishit(mut_mishit(con.back().get_def().mishit));


        con.back().set_inf(pgi);
        x=con.size();
    }

    for(j=1;j<=mischen2;j++) {
        int h=rand()%n;
        int hr=rest_index[h];
        rest_index[h]=rest_index[n];
        n=n-1;

        Group gr(con.at(hr));
        int hs=rest_index[h];
        rest_index[h]=rest_index[n];
        n=n-1;

        Group gr1(con.at(hs));
        Group cr(gr);
        con.push_back(Group((const Group&)gr,40.0,(const Group&)gr1,60.0,generation));
		if (con.back().get_li().size()<=1)  {
            con.pop_back();
        }
        else
        {
            con.back().get_def().set_probelength(cross_probelength(gr.get_def().probelength,gr1.get_def().probelength));
            con.back().get_def().set_mishit(cross_mishit(gr.get_def().mishit,gr1.get_def().mishit));
            con.back().set_inf(pgi);
        }

        x=con.size();
    }

    delete [] ar;
    delete [] rest_index;
    x=con.size();
    if (!search_pool(gbt_tree_step,hash_step)) {
        return false;
    }

    for(unsigned i=0;i<con.size();i++)

        if  (con.at(i).get_birth()<generation) {

            con.at(i).set_history( con.at(i).get_history()+"=");

            if (con.at(i).get_history().length()>=200) con.at(i).set_history( con.at(i).get_history().erase(0,2));

        }
    replic(con.size()-poolsize);

    for(unsigned i=0;i<con.size();i++) {
        con.at(i).set_gen(con.at(i).get_gen()+1);
    }

    return true;
}

//  ------------------------------
//      void POOL:: toString()
//  ------------------------------
void POOL:: toString(){
    for(unsigned i=0;i<con.size();i++)
        con.at(i).toString();
}

//  ---------------------------------------------
//      bool less_specie(Specie x, Specie y)
//  ---------------------------------------------
bool less_specie(Specie x, Specie y) {
    GB_ERROR err=0;

    const  char* namex=x.get_name(err);
    if (err!=0) namex="error";
    const char* namey=y.get_name(err);
    if (err!=0) namey="error";
    return strcmp(namex,namey)<0;
}

//  ----------------------------------------------------
//      bool less_group_mietglied(Group x1,Group y1)
//  ----------------------------------------------------
bool less_group_mietglied(Group x1,Group y1){
    bool less=false;
    unsigned i=0;

    while ((i<x1.get_li().size())&&(!less))
    {
        if ( less_specie(x1.get_li().at(i),y1.get_li().at(i)) ) less=true;
        i++;
    }

    return less;
}

//  -----------------------------------------
//      bool comp_group(Group x, Group y)
//  -----------------------------------------
bool comp_group(Group x, Group y){

    if
        (x.get_li().size()<y.get_li().size())
        return true;
    else if (x.get_li().size()>y.get_li().size()) return false;
    else if ( less_group_mietglied(x,y) ) return true;
    else return false;


}
//  ------------------------------------
//      bool equal(Group x, Group y)
//  ------------------------------------
bool equal(Group x, Group y){

    if (!comp_group(x,y)&&!comp_group(y,x)) return true;
    else
        return false;

}

static container_group_ptr::const_iterator less_group_pool_ptr_begin;
static container_group_ptr::const_iterator less_group_pool_ptr_end;

//  -----------------------------------------------------------------------------
//      bool less_group::is_less(const GroupPtr& x, const GroupPtr& y) const
//  -----------------------------------------------------------------------------
bool less_group::is_less(const GroupPtr& x, const GroupPtr& y) const {

    int idx_x=-1, idx_y=-1;

    container_group_ptr::const_iterator j_iter = less_group_pool_ptr_begin;
    int idx =0;
    while (j_iter!=less_group_pool_ptr_end && (idx_x<0 || idx_y<0)) {
        if (*j_iter==x) idx_x = idx;
        if (*j_iter==y) idx_y = idx;
        idx++;
        j_iter++;
    }

    if (x.get_gr()->get_li().size() < y.get_gr()->get_li().size())
    {return true;}
    if (x.get_gr()->get_li().size() > y.get_gr()->get_li().size())
    {return false;}

    bool less=false;
    unsigned i=0;
    bool greate=false;
    while ((i<x.get_gr()->get_li().size())&&(!less)&&(!greate))
    {
        if ( less_specie(x.get_gr()->get_li().at(i),y.get_gr()->get_li().at(i)) ) less=true;
        if ( less_specie(y.get_gr()->get_li().at(i),x.get_gr()->get_li().at(i)) ) greate=true;

        i++;
    }

    if (less) {return true;}
    if (greate) {return false;}

    if (x.get_gr()->get_inf().quality<y.get_gr()->get_inf().quality)
    {return true;}

    {return false;}
}



//  ---------------------------------------------------------------------------------------
//      GB_ERROR save_Pool(const container_group_ptr& con,int generation,char* zusatz)
//  ---------------------------------------------------------------------------------------
GB_ERROR save_Pool(const container_group_ptr& con,int generation,char* zusatz) {
    string filename;
    {
        char tname[200];
        time_t t;
        struct tm *tm;

        time(&t);
        tm = localtime(&t);
        strftime(tname, 200, "%Y%b%d_%H%M%S", tm);


        filename = string("./probe_group_save_")+tname+zusatz+".arb";
    }

    // @@@ Gruppen nach fitness sortieren!!!

    GBDATA *save_main = GB_open(filename.c_str(), "wct");
    GB_ERROR error = 0;

    if (!save_main) {
        error = GB_export_error("Database %s couldn't be created",filename.c_str());
    }
    else {
        GB_transaction dummy(save_main);

        GBDATA *group_container = GB_create_container(save_main, "probe_groups");

        GBDATA *gen;
        gen = GB_create(group_container, "generation", GB_INT);
        GB_write_int(gen, generation);

        if (group_container) {

            for (container_group_ptr::const_iterator g=con.begin(); !error && g!=con.end(); ++g)

                if  (g->get_gr()->get_inf().seq_list.size()>0)
                {
                    GBDATA *group = GB_create_container(group_container, "group");

                    if (group) {
                        GBDATA *field;

                        field = GB_create(group, "fitness", GB_FLOAT); // relativ (0..1)
                        GB_write_float(field, g->get_gr()->get_inf().fitness);

                        field = GB_create(group, "quality", GB_FLOAT); // absolute
                        GB_write_float(field, g->get_gr()->get_inf().quality);

                        field = GB_create(group, "min_targets", GB_FLOAT);
                        GB_write_float(field, g->get_gr()->get_def().mintargets);

                        field = GB_create(group, "subtree", GB_FLOAT);
                        //printf("get_number_leaf=%d\n",g->get_gr()->get_number_leaf());
                        float subtree;
                        if (g->get_gr()->get_number_leaf()>0)
                            subtree=(float)(g->get_gr()->get_li().size())/(float)(g->get_gr()->get_number_leaf());
                        else subtree=0;

                        GB_write_float(field,subtree);

                        field = GB_create(group, "size", GB_INT);
                        GB_write_int(field, g->get_gr()->get_li().size());

                        field = GB_create(group, "all_leaf", GB_INT);
                        GB_write_int(field, g->get_gr()->get_number_leaf());

                        field = GB_create(group, "mishit", GB_INT);
                        GB_write_int(field, g->get_gr()->get_def().mishit);
                        field = GB_create(group, "probelength", GB_INT);
                        GB_write_int(field, g->get_gr()->get_def().probelength);

                        field = GB_create(group, "birth", GB_INT);
                        int group_gen = g->get_gr()->get_birth();


                        GB_write_int(field, group_gen);

                        GBDATA *species_container = GB_create_container(group, "species");
                        if (species_container) {
                            const PG_species_container& sp = g->get_gr()->get_li();

                            for (PG_species_container::const_iterator s=sp.begin(); !error && s!=sp.end(); ++s) {
                                GBDATA *species = GB_create(species_container, "name", GB_STRING);
                                GB_write_string(species, s->get_name(error));
                            }
                        }

                        GBDATA *probe_container = GB_create_container(group, "probes");
                        if (probe_container) {
                            const PG_sequence_cont& pr = g->get_gr()->get_inf().seq_list;
                            for (PG_sequence_cont::const_iterator p=pr.begin(); !error && p!=pr.end(); ++p) {
                                GBDATA *probe = GB_create(probe_container, "data", GB_STRING);
                                GB_write_string(probe, p->c_str());
                            }
                            GBDATA *probe = GB_create(probe_container, "history", GB_STRING);
                            GB_write_string(probe, g->get_gr()->get_history().c_str());
                        }
                    }
                    if (!error) error = GB_get_error();
                }

        }

        if (!error) error = GB_get_error();
        if (!error) error = GB_save(save_main, (char*)filename.c_str(), "a");

        GB_close(save_main);
    }

    if (!error) error = GB_get_error();
    return error;
}

// #define TRY_ALL_PROBES

#ifdef TRY_ALL_PROBES

//  ----------------------
//      class NextSond
//  ----------------------
class NextSond{

    string zustand;

    int counter_first;
    int counter_second;
    int nukleotid_first;// 1-A, 2-C, 3-G, 4-U
    int nukleotid_second;
    int current_length;
    int max_length;

public:

    string get_zustand(){return zustand;}
    //void set_zustand(string s){zustand=s;}

    void init(){
        zustand="AAAAAAAAAAAAAAA";
        max_length=20;
        nukleotid_first=1;
        nukleotid_second=1;
        current_length=15;
        counter_first=current_length-1;
        counter_second=current_length;
    }
    const string& getnext_Sonde();
    void print_sonde(){printf("%s\n",zustand.c_str());printf("current_length=%d\n",current_length);}

};

const string& NextSond::getnext_Sonde(){

    if (current_length>max_length) {zustand="keine";return zustand;}
    int p=current_length-1;


 mi:
    if (zustand[p]!='U') {
        switch(zustand[p]) {
            case 'A':zustand[p]='C';break;
            case 'C':zustand[p]='G';break;
            case 'G':zustand[p]='U';break;
        }
        return zustand;
    }
    else {
        zustand[p]='A';
        p=p-1;
        if ((p==0) && (zustand[p]=='U'))
            if (current_length>max_length)
            {  zustand="keine";exit(0);return zustand;}
            else
            {current_length++;
            char init_zust[current_length+1];
            int i;
            for (i=0;i<current_length;i++)
                init_zust[i]='A';
            init_zust[i]=0;
            zustand=init_zust;
            return zustand;
            }
        goto mi;
    }
    return zustand;
}

#else // TRY_ALL_PROBES

//  -----------------------
//      class NextSond
//  -----------------------
class NextSond {
    int min_length;
    int max_length;
    GB_ERROR error;
    bool initialized;
    string pt_servername;

    void Init() {
        pg_assert(!initialized);
        PG_init_find_probes(pt_servername.c_str(), min_length, error);
        initialized = true;
    }
    void Exit() {
        pg_assert(initialized);
        PG_exit_find_probes();
        initialized = false;
    }

public:
    NextSond(int min_len, int max_len, const char *pt_servername_) :
        min_length(min_len),
        max_length(max_len),
        error(0),
        initialized(false),
        pt_servername(pt_servername_)
    {
        Init();
    }

    ~NextSond() {
        if (initialized) Exit();
    }

    const char *getnext_Sonde() { // return 0 if no more probes
        pg_assert(!error);
        const char *next_probe = 0;
        while (1) {
            next_probe = PG_find_next_probe(error);

            if (next_probe) break; // found a probe?
            if (min_length>=max_length) break; // max length reached?

            // increase probe length:
            min_length++;
            Exit();
            Init();
        }

        return next_probe;
    }

    GB_ERROR get_error() const  { return error; }
};


#endif // TRY_ALL_PROBES


//  -----------------------------------------
//      static GB_ERROR save(POOL& pool)
//  -----------------------------------------
static GB_ERROR save(POOL& pool) {
    GB_ERROR error =0;

    container_group_ptr pool_ptr;
    error=0;
    for (unsigned j=0;j<pool.get_con().size();j++) {
        sort (pool.get_con()[j].get_li().begin(), pool.get_con()[j].get_li().end(), less_name());
    }
    int nu=0;
    for ( container_group::iterator iter=pool.get_con().begin();iter<pool.get_con().end();iter++) {
        pool_ptr.push_back(GroupPtr(iter,nu));
        nu++;
    }

    /*sort*/

    less_group_pool_ptr_begin = pool_ptr.begin();
    less_group_pool_ptr_end = pool_ptr.end();
    sort (pool_ptr.begin(),pool_ptr.end(),less_group());

    reverse(pool_ptr.begin(),pool_ptr.end());
    if (pool_ptr.size()>0) pool_ptr[0].set_del_mi(false);
    if (pool_ptr.size()>1) {
        for(unsigned i=1;i<pool_ptr.size();i++) {
            if ( equal(*(pool_ptr[i-1]).get_gr(),*(pool_ptr[i].get_gr()) ) ) {
                pool_ptr[i].set_del_mi(true);
            }
        }
    }

    /*remove_if*/
    container_group_ptr::iterator new_end=remove_if(pool_ptr.begin(),pool_ptr.end(),if_del());

//     int i=1;
//     for( container_group_ptr::iterator iter=pool_ptr.begin();iter<pool_ptr.end();iter++) {
//         i++;
//     }
    pool_ptr.erase(new_end,pool_ptr.end());

    sort (pool_ptr.begin(),pool_ptr.end(),less_group_quality());
    reverse(pool_ptr.begin(),pool_ptr.end());
    /*save_pool*/

    error= save_Pool(pool_ptr,pool.get_gen(),"a");
    pool_ptr.clear();
    pool.get_con().erase(pool.get_con().begin(),pool.get_con().end());

    return error;
}

//  ---------------------------
//      static void help()
//  ---------------------------
static void help() {
    cerr << "Usage: arb_probe_group \"database\" \"treename\" \"pt_servername\" [<options>]*\n";
    cerr << "Purpose: Build all species-groups for all existing probes\n";
    cerr << "option::= --poolsize <size> (default=10)\n";
    cerr << "          --groupsize <size> (default=5)\n";

    cerr << "          --groupart <0/1> (Initial-Gruppen erzeugen 1=zufaellig aus allen[default]; 0=geordnetaus markierten)\n";
    cerr << "          --time <stunden> (default=10 Stunden)\n";
    cerr << "          --savetime <minuten> (default=5 Minuten)\n";
    cerr << "          --mutation_number <prozent von pool> (default=50)\n";
    cerr << "          --crossover_number <prozent von pool> (default=50)\n";
    cerr << "          --new_number <prozent von pool> (default=50; zusaetzlich erzeugt pro Step)\n";
    cerr << "          --max_groupsize <size> (default=50)\n";

    cerr << "Bewertung:\n";

    cerr << "          --count_all_probes <0/1> (0=nur die beiden besten Sonden werten[default]; 1=alle Sonden werten\n";
    cerr << "          --sond_exist_value <val> (default=1.0; Faktor pro existierende Sonde)\n";
    cerr << "          --sond_value       <val> (default=1.0; Faktor fuer Sondenqualitaet)\n";
    cerr << "          --koefmintargets   <val> (default=1.0; Faktor fuer MinTargets)\n";
    cerr << "          --koefmishits      <val> (default=1.0; Faktor fuer MisHits-Bewertung)\n";
    cerr << "          --norm             <val> (default=100; Faktor fuer Kompaktheit der Gruppen)\n";
    cerr << "          --norm_groesse     <val> (default=2.0; Faktor fuer Groesse der Gruppen)\n";
    cerr << "          --all_part    <0/1> (Gruppen erzeugen: 1 aus ganzen Baum, 0 aus Unterbaum)\n";

    exit(EXIT_FAILURE);
}

//  ------------------------------------------------------------
//      static void parameter_missing(const char *opt_name)
//  ------------------------------------------------------------
static void parameter_missing(const char *opt_name) {
    cerr << "Option " << opt_name << " awaits a parameter.\n";
    help();
}

//  --------------------------------------------------
//      void scanParameters(int argc, char **argv,
//  --------------------------------------------------
void scanParameters(int argc, char **argv,
                        const char *&par_data_path, const char *&par_tree_name, const char *&par_servername,
                        int& para_poolsize, int& para_groupsize,
                        bool& bool_wert, bool& all_wert,
                        int& par_zeit, int& par_speicher_zeit, int&par_zufall,
                        int& par_neue, int& par_mischen, int& par_maxgroupsize,
                        double& par_wert, double& par_wertq, double& par_koefmintargets,
                        double& par_koefmishits, double& par_norm, double& par_norm_groesse,
                        bool& par_count_all_probes
                        ) {
    par_data_path = argv[1];
    par_tree_name = argv[2];
    par_servername = argv[3];

    argc-=3; argv+=3;

    while (argc>1) { // solange noch weitere Argumente

        if (strcmp(argv[1],"--poolsize")==0) {
            if (argc==2) { // kein parameter hinter --poolsize
                parameter_missing(argv[1]);
            }
            para_poolsize = strtol(argv[2],0,10);
            if (para_poolsize<1 ) {printf("pool_size zu klein\n");  exit(EXIT_FAILURE);}
            argc--; argv++;
        }
        else if (strcmp(argv[1],"--groupsize")==0) {
            if (argc==2) { // kein parameter hinter --groupsize
                parameter_missing(argv[1]);
            }
            para_groupsize = strtol(argv[2],0,10);
            if (para_groupsize<1 ) {printf("group_size zu klein\n");  exit(EXIT_FAILURE);}
            argc--; argv++;
        }
        else if (strcmp(argv[1],"--groupart")==0) {
            if (argc==2) { // kein parameter hinter --groupart
                parameter_missing(argv[1]);
            }
            bool_wert = strtol(argv[2],0,10)==0 ? false : true;
            argc--; argv++;
        }
        else if (strcmp(argv[1],"--count_all_probes")==0) {
            if (argc==2) { // kein parameter hinter --count_all_probes
                parameter_missing(argv[1]);
            }
            par_count_all_probes = strtol(argv[2],0,10)==0 ? false : true;
            argc--; argv++;
        }
        else if (strcmp(argv[1],"--time")==0) {
            if (argc==2) { // kein parameter hinter --time
                parameter_missing(argv[1]);
            }
            par_zeit = strtol(argv[2],0,10);
            if (par_zeit<0 ) {printf("Zeit kann nicht negativ sein");  exit(EXIT_FAILURE);}
            argc--; argv++;
        }
        else if (strcmp(argv[1],"--savetime")==0) {
            if (argc==2) { // kein parameter hinter --savetime
                parameter_missing(argv[1]);
            }
            par_speicher_zeit = strtol(argv[2],0,10);
            if (par_speicher_zeit<0 ) {printf("Zeit kann nicht negativ sein");  exit(EXIT_FAILURE);}
            if (par_speicher_zeit>par_zeit ) {printf("savetime>time");  exit(EXIT_FAILURE);}
            argc--; argv++;
        }
        else if (strcmp(argv[1],"--mutation_number")==0) {
            if (argc==2) { // kein parameter hinter --mutation_number
                parameter_missing(argv[1]);
            }
            par_zufall = strtol(argv[2],0,10);
            if (par_zufall<0 ) {printf("mutation_number negativ");  exit(EXIT_FAILURE);}
            argc--; argv++;
        }
        else if (strcmp(argv[1],"--new_number")==0) {
            if (argc==2) { // kein parameter hinter --new__number
                parameter_missing(argv[1]);
            }
            par_neue = strtol(argv[2],0,10);
            if (par_neue<0 ) {printf("new_namber negativ");  exit(EXIT_FAILURE);}
            argc--; argv++;
        }
        else if (strcmp(argv[1],"--crossover_number")==0) {
            if (argc==2) { // kein parameter hinter --crossover__number
                parameter_missing(argv[1]);
            }
            par_mischen = strtol(argv[2],0,10);
            if (par_mischen<0 ) {printf("new_namber negativ");  exit(EXIT_FAILURE);}
            argc--; argv++;
        }
        else
            if (strcmp(argv[1],"--max_groupsize")==0) {
                if (argc==2) { // kein parameter hinter --max_groupsize
                    parameter_missing(argv[1]);
                }
                par_maxgroupsize = strtol(argv[2],0,10);
                if ( par_maxgroupsize<1 ) {printf("max_groupsize is smoll");  exit(EXIT_FAILURE);}
                argc--; argv++;
            }
            else if (strcmp(argv[1],"--sond_exist_value")==0) {
                if (argc==2) { // kein parameter hinter --sond_exist_value
                    parameter_missing(argv[1]);
                }
                par_wert = strtod(argv[2],0);
                if ( par_wert<0 ) {printf("sond_exist_value is negativ");  exit(EXIT_FAILURE);}
                argc--; argv++;
            }
            else if (strcmp(argv[1],"--sond_value")==0) {
                if (argc==2) { // kein parameter hinter --sond_value
                    parameter_missing(argv[1]);
                }
                par_wertq = strtod(argv[2],0);
                if ( par_wert<0 ) {printf("sond_value is negativ");  exit(EXIT_FAILURE);}
                argc--; argv++;
            }
            else if (strcmp(argv[1],"-- koefmintargets")==0) {
                if (argc==2) { // kein parameter hinter -- koefmintargets
                    parameter_missing(argv[1]);
                }
                par_koefmintargets = strtod(argv[2],0);
                if ( par_koefmintargets <0 ) {printf(" koefmintargets is negativ");  exit(EXIT_FAILURE);}
                argc--; argv++;
            }
            else if (strcmp(argv[1],"--koefmishits")==0) {
                if (argc==2) { // kein parameter hinter --koefmishits
                    parameter_missing(argv[1]);
                }
                par_koefmishits = strtod(argv[2],0);
                if ( par_koefmishits <0 ) {printf(" koefmishits is negativ");  exit(EXIT_FAILURE);}
                argc--; argv++;
            }
            else if (strcmp(argv[1],"--norm")==0) {
                if (argc==2) { // kein parameter hinter -- norm
                    parameter_missing(argv[1]);
                }
                par_norm = strtod(argv[2],0);
                if (  par_norm <0 ) {printf(" norm is negativ");  exit(EXIT_FAILURE);}
                argc--; argv++;
            }
            else if (strcmp(argv[1],"--norm_groesse")==0) {
                if (argc==2) { // kein parameter hinter -- norm_groesse
                    parameter_missing(argv[1]);
                }
                par_norm_groesse = strtod(argv[2],0);
                if ( par_norm_groesse <0 ) {printf(" norm_groesse is negativ");  exit(EXIT_FAILURE);}
                argc--; argv++;
            }
            else if (strcmp(argv[1],"--all_part")==0) {
                if (argc==2) { // kein parameter hinter --groupart
                    parameter_missing(argv[1]);
                }
                all_wert = strtol(argv[2],0,10)==0 ? false : true;
                argc--; argv++;
            }
            else {
                cerr << "Unknown option " << argv[1] << "\n";
                help();
            }
        argc--; argv++;
    }
}

//  -----------------------------------------
//      int main(int argc, char *argv[])
//  -----------------------------------------
int main(int argc, char *argv[]) {
    GB_ERROR error = 0;

// #define PT_TEST

#if defined(PT_TEST)

    for (int len=15; !error && len<=20; ++len) {
        if (PG_init_find_probes("localhost: user7.arb", len, error)) {
            int count = 0;

            while (!error) {
                const char *next_probe = PG_find_next_probe(error);
                if (!next_probe) break;
                printf("next_probe='%s'\n", next_probe);
                count++;
            }

            printf("count=%i\n", count);
            PG_exit_find_probes();
        }
    }
    if (error) printf("Error: %s\n", error);

    return 0;

#else // PT_TEST


    time_t seed = time(0);
    //time_t seed =981716385;
    srand(seed);

    time_t t;
    int n=time(&t);
    printf("time=%d\n",n);

    if (argc<4 || strcmp(argv[1],"--help")==0 || strcmp(argv[1],"-h")==0) {
        help();
    }

    const char *par_data_path = 0;
    const char *par_tree_name =0; //="tree_raw_2";
    const char *par_servername =0; //= "bamberg.arb";

    int para_poolsize = 8;
    int para_groupsize=5;
    bool bool_wert=true;
	bool all_wert=true;
    int par_zeit=10;//in Stunden
    int par_speicher_zeit=10;//in Minuten
    int par_zufall=50;
    int par_neue=50;
    int par_mischen=50;
    int par_maxgroupsize=200;
    double par_wert=1;
    double par_wertq=1;
    double par_koefmintargets=1;
    double par_koefmishits=1;
    double par_norm=100;
    double par_norm_groesse=2;
    bool par_count_all_probes = 0;

    scanParameters(argc, argv,
                   par_data_path, par_tree_name, par_servername,
                   para_poolsize,  para_groupsize,
                   bool_wert,  all_wert,
                   par_zeit,  par_speicher_zeit, par_zufall,
                   par_neue,  par_mischen,  par_maxgroupsize,
                   par_wert,  par_wertq,  par_koefmintargets,
                   par_koefmishits,  par_norm,  par_norm_groesse,
                   par_count_all_probes
                   );


    gb_main = GBT_open(par_data_path, "rwt", 0);
    if (!gb_main)
    {
        if (!GB_get_error()) GB_export_error("Can't open database '%s'", par_data_path);
        GB_print_error();
        exit (-1);
    }

    {
        GB_ERROR error = GB_get_error();
        if (error) {
            GB_print_error();
            exit(-1);
        }
    }

    int zufall2;
    int mischen2;
    zufall2=(para_groupsize*par_zufall)/100;

    mischen2=(para_groupsize*par_mischen)/(100*2);

	if ( mischen2*2+zufall2>para_groupsize ) {
        printf("Anzahl von Crossover+Anzahl von Mutationen ist grosser all groupsize ");
        exit(EXIT_FAILURE);
    }

    GBT_TREE* gbt_tree;
    GB_HASH* gb_hash;
    {
        GB_transaction dummy(gb_main);

        gbt_tree=GBT_read_tree(gb_main,par_tree_name,sizeof(GBT_TREE));
        if (!gbt_tree)  {
            GB_export_error("Tree '%s' not found.", par_tree_name);
            GB_print_error();
            exit(-1);
        }
        GBT_link_tree(gbt_tree,gb_main,true);
        gb_hash=generate_GBT_TREE_hash(gbt_tree);
    }

    char buffer[60];
    sprintf(buffer,"localhost: %s",par_servername);

    string ptserver_name(buffer);


    class POOL pool(gb_main,gbt_tree,ptserver_name,para_poolsize ,para_groupsize,bool_wert,all_wert);

    pool.set_minprobelength(15);
    pool.set_maxprobelength(20);
    pool.set_lomintargets(50);
    pool.set_himintargets(100);
    pool.set_lomishit(0);
    pool.set_himishit(10);

    PG_inform pginf;
    Group::set_count_all(par_count_all_probes);
    Group::set_wert(par_wert);
    Group::set_wertq(par_wertq);
    Group::set_koefmintargets(par_koefmintargets);
    Group::set_koefmishits(par_koefmishits);
    Group::set_norm(par_norm);
    Group::set_norm_groesse(par_norm_groesse);

    for (unsigned j=0;j<pool.get_con().size();j++) {
        pool.get_con()[j].get_def().set_probelength(pool.get_minprobelength());
        pool.get_con()[j].get_def().set_cliptresult(50);
        pool.get_con()[j].get_def().set_mintemp(30);
        pool.get_con()[j].get_def().set_maxtemp(100);
        pool.get_con()[j].get_def().set_mishit(pool.get_himishit());
        pool.get_con()[j].get_def().set_mintargets(pool.get_himintargets());
        pool.get_con()[j].get_def().set_mingc(50);
        pool.get_con()[j].get_def().set_maxgc(100);
        pool.get_con()[j].get_def().set_minpos(0);
        pool.get_con()[j].get_def().set_maxpos(10000);
        pool.get_con()[j].get_def().set_dtedge(0.5);
        pool.get_con()[j].get_def().set_dt(0.5);
        pool.get_con()[j].get_def().set_split(0.5);
        pool.get_con()[j].get_def().set_bondval(0,0);


        pool.get_con()[j].get_def().set_bondval(0,1);
        pool.get_con()[j].get_def().set_bondval(0.5,2);
        pool.get_con()[j].get_def().set_bondval(1.1,3);
        pool.get_con()[j].get_def().set_bondval(0,4);
        pool.get_con()[j].get_def().set_bondval(0,5);
        pool.get_con()[j].get_def().set_bondval(1.5,6);
        pool.get_con()[j].get_def().set_bondval(0,7);
        pool.get_con()[j].get_def().set_bondval(0.5,8);
        pool.get_con()[j].get_def().set_bondval(1.5,9);
        pool.get_con()[j].get_def().set_bondval(0.4,10);
        pool.get_con()[j].get_def().set_bondval(0.9,11);
        pool.get_con()[j].get_def().set_bondval(1.1,12);
        pool.get_con()[j].get_def().set_bondval(0,13);
        pool.get_con()[j].get_def().set_bondval(0.9,14);
        pool.get_con()[j].get_def().set_bondval(0,15);
        pool.get_con()[j].get_def().set_maxbonds(4);
        pool.get_con()[j].set_inf(pginf);
	}
	pool.get_con().erase(pool.get_con().begin(),pool.get_con().end());
	class NextSond gener(15, 15, ptserver_name.c_str());

    while(true) {
        // get next probe from server:
        if ((error=gener.get_error())) {
            break;
        }

        const char *next_probe = gener.getnext_Sonde();
        if (!next_probe) break;

        Group gr(gb_main,gbt_tree,pool.get_a());

        gr.get_def().set_probelength(pool.get_minprobelength());
        gr.get_def().set_cliptresult(50);
        gr.get_def().set_mintemp(30);
        gr.get_def().set_maxtemp(100);
        gr.get_def().set_mishit(pool.get_himishit());
        gr.get_def().set_mintargets(pool.get_himintargets());
        gr.get_def().set_mingc(50);
        gr.get_def().set_maxgc(100);
        gr.get_def().set_minpos(0);
        gr.get_def().set_maxpos(10000);
        gr.get_def().set_dtedge(0.5);
        gr.get_def().set_dt(0.5);
        gr.get_def().set_split(0.5);
        gr.get_def().set_bondval(0,0);


        gr.get_def().set_bondval(0,1);
        gr.get_def().set_bondval(0.5,2);
        gr.get_def().set_bondval(1.1,3);
        gr.get_def().set_bondval(0,4);
        gr.get_def().set_bondval(0,5);
        gr.get_def().set_bondval(1.5,6);
        gr.get_def().set_bondval(0,7);
        gr.get_def().set_bondval(0.5,8);
        gr.get_def().set_bondval(1.5,9);
        gr.get_def().set_bondval(0.4,10);
        gr.get_def().set_bondval(0.9,11);
        gr.get_def().set_bondval(1.1,12);
        gr.get_def().set_bondval(0,13);
        gr.get_def().set_bondval(0.9,14);
        gr.get_def().set_bondval(0,15);
        gr.get_def().set_maxbonds(4);
        gr.set_inf(pginf);

        gr.get_inf().seq_list.push_back(next_probe);

        Specie *bad;
        probe_match_event(gr,pool.get_server_name().c_str(),bad,error,gbt_tree,gb_hash);
        if (gr.get_li().size()>0)
        {
            gr.set_lowest_father(gr.get_all_father());
            pg_assert(gr.is_lowest_father());
            gr.set_number_leaf(number_leaf(gr.get_lowest_father()));
            pool.get_con().push_back(gr);

            if (pool.get_con().size()>10000) {
                error = save(pool);
            }
        }
    }

    // save rest
    if (pool.get_con().size()>0) {
        error = save(pool);
    }

    if (error) {
        fprintf(stderr, "Error in arb_probe_group: %s\n", error);
    }

    GBS_free_hash(gb_hash);
    return 0;
#endif // PT_TEST
}

