#include <arbdb.h>
#include <sys/types.h>
#include <string.h>
#include <rpc/types.h>
#include <map>
#include <list>
 struct pos {
    int begin;
    int end;
 };


  
int main(int argc, char* argv[]) {

  GBDATA* root = NULL;           // Zeiger auf den Rootknoten des ganzen Baumes
  
  GBDATA* species_data_ptr = NULL;  // Zeiger auf die original species_data
  GBDATA* species2_data_ptr = NULL;  // Zeiger auf die neuen species_data
  
  GBDATA* species1_ptr = NULL;  // Zum durchiterieren der original Spezies
  GBDATA* species2_ptr = NULL;  // Fuer die Neuen Gen-Spezies
  GBDATA* gene1_ptr = NULL;  // Zum durchiterieren der original Gene
  
  GBDATA* gene_data_ptr = NULL; //Daten der neuen GenSpezies
  
  GBDATA* gene_name_ptr = NULL;  // Der Genname
  GBDATA* gene_pos_begin_ptr = NULL;
  GBDATA* gene_pos_end_ptr = NULL;
  
  GBDATA* map_ptr = NULL;
  
  GBDATA* ali_genom_ptr = NULL;
  GBDATA* species_name_ptr = NULL;
  
  GBDATA* temp1 = NULL;
  GBDATA* temp2 = NULL;
  

  GB_ERROR error = 0;
  

  
  pos temppos;

  int mapsize = 0;
  
  map<const char *,char *> names;
  map<const char *,char *> names_reverse;

  map<const char*,char*>::iterator NameIter;
  map<const char*,char*>::iterator RNameIter;

    NameIter = names.begin();
  list <pos> pos_list;

  int pos_begin_old;
  int pos_end_old;
  int pos_begin;
  int pos_end;
  int normalcounter = 0;
  int introncounter = 0;
  int pos_search = 2;
  
  char split_counter;
  char gene_name[128];
  char species_name[128];
  char* total_name;//[256];
  char* genspec_name;//[128];
  char* gensequenz;
  char* map_string;
  char temp_string[512];
  char pos_begin_string[12];
  char pos_end_string[12];
  //  char *char_counter = "aaaaaa";

  char* ali_genom;
  
    
  int type;
 
  int a = 0;
  int i,j;
  root = GB_open(argv[1],"rw");  // rootzeiger wird gesetzt
  GB_begin_transaction(root);
 

  species_data_ptr = GB_find(root,"species_data",0,down_level);
  species2_data_ptr = GB_create_container(root,"species_data");

  species1_ptr = GB_find(species_data_ptr,"species",0,down_level);// Der Zeiger auf die erste Spezies
  
  if (species1_ptr == NULL) {printf("nothing found\n");exit(1);};

  map_ptr = GB_create_container(root,"gene_map");

  do { // Gehe durch alle Spezies
    ali_genom_ptr = GB_find(species1_ptr,"data",0,down_2_level); // Das genom der Spezies
    species_name_ptr = GB_find(species1_ptr,"name",0,down_level); // Name dr Spezies
    strcpy(species_name,GB_read_char_pntr(species_name_ptr));
    
    gene1_ptr = GB_find(species1_ptr,"gene",0,down_2_level);  // Finde das erste Gen
    
    
    // Die alten Anfangspositionen muessen fuer jede neue Spezies resettet werden
    pos_begin_old = 1;
    pos_end_old = 1;
    
    do { // Gehe ueber alle Gene
      
      if (gene1_ptr == NULL) {continue;};
      
      normalcounter++;
      pos_search = 2;
      gene_name_ptr = GB_find(gene1_ptr,"name",0,down_level);
      gene_pos_begin_ptr = GB_find(gene1_ptr,"pos_begin",0,down_level);
      gene_pos_end_ptr = GB_find(gene1_ptr,"pos_end",0,down_level);
      strcpy (gene_name,GB_read_char_pntr(gene_name_ptr));
      pos_begin = GB_read_int(gene_pos_begin_ptr);
      pos_end = GB_read_int(gene_pos_end_ptr);
      ali_genom = GB_read_char_pntr(ali_genom_ptr);

      // ueberuefen ob Gen gesplittet
      temp1 = GB_find(gene1_ptr,"pos_begin",0,down_level);
      temp2 = GB_find(gene1_ptr,"pos_end",0,down_level);
      temppos.begin = GB_read_int(temp1);
      temppos.end = GB_read_int(temp2);

      pos_list.push_back(temppos);
	
      sprintf(pos_begin_string,"pos_begin%i",pos_search);
      while ((temp1 = GB_find(gene1_ptr,pos_begin_string,0,down_level))) {
	sprintf(pos_end_string,"pos_end%i",pos_search);
	temp2 = GB_find(gene1_ptr,pos_end_string,0,down_level);
	
	temppos.begin = GB_read_int(temp1);
	temppos.end = GB_read_int(temp2);

	pos_list.push_back(temppos);
	
	pos_search++;
	sprintf(pos_begin_string,"pos_begin%i",pos_search);
	printf("Gen gesplittet\n");
	
      }
	
      list<pos>::iterator PosIter;

      PosIter = pos_list.begin();
      
      while (!pos_list.empty()) {
	pos_begin = PosIter->begin;
	pos_end = PosIter->end;
	
	PosIter++;
	pos_list.pop_front();
	
	if (pos_end_old == 1 && pos_begin > 1) {
	  // Gene Starten nicht am Anfang
	  
	  
	  species2_ptr = GB_create_container(species2_data_ptr,"species");
	  
	  temp1 = GB_create(species2_ptr,"name",GB_STRING);
	  genspec_name = new char[128];
	  sprintf(genspec_name,"i%x",introncounter);
	  total_name = new char[256];
	  sprintf(total_name,"%s/%s",species_name,gene_name);
	  mapsize += strlen(total_name) + strlen(genspec_name);
	  
	  names[genspec_name] = total_name;
	  NameIter++;
	  
	  introncounter++;
	  GB_write_string(temp1,genspec_name);
	  
	  /*testcontainer
	  temp1 = GB_create(species2_ptr,"genname",GB_STRING);
	  GB_write_string(temp1,gene_name);
	  temp1 = GB_create(species2_ptr,"specname",GB_STRING);
	  GB_write_string(temp1,species_name);*/
	  
	  

	  temp2 = GB_create_container(species2_ptr,"ali_genom");
	  temp1 = GB_create(temp2,"data",GB_STRING);
	  
	  gensequenz = new char[(pos_begin - pos_end_old)+1]; 
	  j=0;
	  
	  for (i = pos_end_old; i < pos_begin; i++) {
	    gensequenz[j++] = ali_genom[i];
	  }
	  gensequenz[j] = '\0';
	  
	  GB_write_string(temp1,gensequenz);
	  
	  delete (gensequenz);
	  
	  
	}
	
	if ((pos_end_old < pos_begin-1) && (pos_end_old > 1)) { 
	  // Falls zwischen zwei Genen Basen sind
	  
	  species2_ptr = GB_create_container(species2_data_ptr,"species");
	  
	  temp1 = GB_create(species2_ptr,"name",GB_STRING);
	  genspec_name = new char[128];
	  sprintf(genspec_name,"i%x",introncounter);
	  total_name = new char[256];
	  sprintf(total_name,"%s/%s",species_name,gene_name);
	  mapsize += strlen(total_name) + strlen(genspec_name);
	  
	  names[genspec_name] = total_name;
	  NameIter++;
	  //cout << names[genspec_name] << endl;

	  introncounter++;
	  GB_write_string(temp1,genspec_name);

	  temp2 = GB_create_container(species2_ptr,"ali_genom");
	  temp1 = GB_create(temp2,"data",GB_STRING);

	  gensequenz = new char[(pos_begin - pos_end_old)]; 
	  j=0;
	  
	  for (i = pos_end_old+1; i < pos_begin; i++) {
	    gensequenz[j++] = ali_genom[i];
	  }
	  gensequenz[j] = '\0';

	  GB_write_string(temp1,gensequenz);

	  delete (gensequenz);

	}


	split_counter = 'a';
	species2_ptr = GB_create_container(species2_data_ptr,"species");

	temp1 = GB_create(species2_ptr,"name",GB_STRING);
	
	if(pos_search <= 2) {
	  genspec_name = new char[128];
	  sprintf(genspec_name,"n%x",normalcounter);
	  total_name = new char[256];
	  sprintf(total_name,"%s/%s",species_name,gene_name);
	  mapsize += strlen(total_name) + strlen(genspec_name);
	  
	  names[genspec_name] = total_name;
	  NameIter++;

	}
	else {
	  printf("Split\n");
	  genspec_name = new char[128];
	  sprintf(genspec_name,"s%x%c",normalcounter,split_counter);
	  total_name = new char[256]; 
	  sprintf(total_name,"%s/%s",species_name,gene_name);
	  mapsize += strlen(total_name) + strlen(genspec_name);
	
	  names[genspec_name] = total_name;
	  NameIter++;

	  split_counter++;
	}
	GB_write_string(temp1,genspec_name);

	temp2 = GB_create_container(species2_ptr,"ali_genom");
	temp1 = GB_create(temp2,"data",GB_STRING);
	
	gensequenz = new char[(pos_end - pos_begin)+2]; 
	j=0;
	
	for (i = pos_begin; i <= pos_end; i++) {
	  gensequenz[j++] = ali_genom[i];
	}
	gensequenz[j] = '\0';
	
	GB_write_string(temp1,gensequenz);
	
	delete (gensequenz);

	pos_end_old = pos_end;
	pos_begin_old = pos_begin;

      }
    }while (gene1_ptr = GB_find(gene1_ptr,0,0,this_level|search_next));
  }while (species1_ptr = GB_find(species1_ptr,0,0,this_level|search_next));

  GB_delete(species_data_ptr);
 
  
  NameIter = names.begin();
  
  FILE* file;
  file = fopen("../test.map","w");

  mapsize += names.size()*6;
  mapsize +=2;

  map_string = new char[mapsize]; 
  map_string[0] = '\0';
 
  while (NameIter != names.end()) {
    sprintf(temp_string,"%s ; %s\n",NameIter->first,NameIter->second);
    strcat(map_string,temp_string);
    NameIter++;
  }

  temp1 = GB_create(map_ptr,"map_string",GB_STRING);
  GB_write_string(temp1,map_string);

  GB_save_as(root,"../test.arb","b");
  GB_save_as(root,"../test.txt","a");
  fprintf(file,map_string);

}



